; Startup for the #amycoders 384 bytes demo compo by Blueberry/Efreet.

; QuickFixed by Harry "Piru" Sintonen 15th July 1998:
;
;  1) Didn't require KS V39 -> Crash on pre-V39 (at least pre-V37).
;  2) Didn't restore original task priority.
;  3) TAG_END was missing from ProcessParams taglist.
;  4) Improved interleaved test a bit.
;  5) It wasn't possible to compile intro with Devpac because use
;     of basereg and global\.local references.
;  6) Fixed loads of "Warning: trailing comma at end of DC directive"
;

	incdir	dh1:s_aga12/384BytesCompo/
	include	systemdefs.i

call	macro
	jsr	_LVO\1(a6)
	endm
	
	section	code,code

Startup:
	move.l	$4.w,a6
	lea.l	IntName(pc),a1
	moveq.l	#39,d0
	call	OpenLibrary
	move.l	d0,IntBase
	beq.w	.noint
	lea.l	GfxName(pc),a1
	moveq.l	#39,d0
	call	OpenLibrary
	move.l	d0,GfxBase
	beq.w	.nogfx
	lea.l	DosName(pc),a1
	moveq.l	#39,d0
	call	OpenLibrary
	move.l	d0,DosBase
	beq.w	.nodos

	; Open screen.
	move.l	IntBase(pc),a6
	suba.l	a0,a0
	lea.l	ScreenParams(pc),a1
	call	OpenScreenTagList
	move.l	d0,_Screen
	beq.b	.noscr
	; Ensure that the screen is interleaved.
	move.l	d0,a0
	move.l	sc_RastPort+rp_BitMap(a0),a1
	move.l	bm_Planes+4(a1),d1
	sub.l	bm_Planes(a1),d1
	lsl.l	#3,d1			; HS: *DEPTH
	cmp.w	bm_BytesPerRow(a1),d1
	bne.b	.notil			; HS: fix
	; Put BitMap1 into _Screen->ViewPort.RasInfo
	move.l	sc_ViewPort+vp_RasInfo(a0),a1
	move.l	#BitMap1,ri_BitMap(a1)

	; Set own priority to 0.
	move.l	$4.w,a6
	suba.l	a1,a1
	call	FindTask
	move.l	d0,a1
	moveq.l	#0,d0
	move.l	a1,-(sp)		; HS: store thistask
	call	SetTaskPri
	move.l	d0,-(sp)		; HS: store old pri!

	; Create VBlank process.
	move.l	DosBase(pc),a6
	move.l	#ProcessParams,d1
	call	CreateNewProc
	move.l	d0,Process
	beq.b	.nopro

	bsr.w	DoTheJob

.nopro:
	move.l	$4.w,a6			; HS: restore pri
	move.l	(sp)+,d0
	move.l	(sp)+,a1
	call	SetTaskPri

.notil:	move.l	IntBase(pc),a6
	move.l	_Screen(pc),a0
	call	CloseScreen
.noscr:	move.l	$4.w,a6
	move.l	DosBase(pc),a1
	call	CloseLibrary
.nodos:	move.l	GfxBase(pc),a1
	call	CloseLibrary
.nogfx:	move.l	IntBase(pc),a1
	call	CloseLibrary
.noint:	moveq.l	#0,d0
	rts

ScreenParams:
	dc.l	SA_Left,0		; HS: not really needed.
	dc.l	SA_Top,0		; HS: not really needed.
	dc.l	SA_Width,320
	dc.l	SA_Height,256
	dc.l	SA_Depth,8
	dc.l	SA_ShowTitle,0
	dc.l	SA_BitMap,BitMap1
	dc.l	SA_Quiet,1
	dc.l	SA_Type,CUSTOMSCREEN
	dc.l	SA_DisplayID,PAL_MONITOR_ID
	dc.l	SA_Interleaved,1	; HS: not really needed.
	dc.l	TAG_END

ProcessParams:
	dc.l	NP_Entry,VBlankProcess
	dc.l	NP_Name,ProcessName
	dc.l	NP_Priority,1
	dc.l	TAG_END			; HS: WAS MISSING!

BitMap1:
	dc.w	8*40,256,8,0
	dc.l	Planes1+0*40,Planes1+1*40,Planes1+2*40,Planes1+3*40
	dc.l	Planes1+4*40,Planes1+5*40,Planes1+6*40,Planes1+7*40

BitMap2:
	dc.w	8*40,256,8,0
	dc.l	Planes2+0*40,Planes2+1*40,Planes2+2*40,Planes2+3*40
	dc.l	Planes2+4*40,Planes2+5*40,Planes2+6*40,Planes2+7*40

IntBase:	dc.l	0
GfxBase:	dc.l	0
DosBase:	dc.l	0
_Screen:	dc.l	0
OldBitMap:	dc.l	0
Process:	dc.l	0
OldStack:	dc.l	0
ProcessState:	dc.w	0
C2P1x1State:	dc.w	0
C2P2x1State:	dc.w	0
C2PEdgeState:	dc.w	0

IntName:	dc.b	'intuition.library',0
GfxName:	dc.b	'graphics.library',0
DosName:	dc.b	'dos.library',0
ProcessName:	dc.b	'VBlank process',0
		even

;; ******************** Calling shell ********************

DoTheJob:
	move.l	a7,OldStack
	move.w	#$000f,$dff096
	bsr.w	Init
	movem.l	d0-a6,Registers
	move.w	#1,ProcessState
.wait1:	cmp.w	#2,ProcessState	; Wait for VBlank process to begin.
	bne.b	.wait1
	bsr.w	Main

Exit:
	move.w	#$000f,$dff096
	move.l	OldStack(pc),a7
	move.w	#3,ProcessState
.wait2:	cmp.w	#4,ProcessState	; Wait for VBlank process to end.
	bne.b	.wait2
	rts

VBlankProcess:
.loop1:	move.l	GfxBase(pc),a6
	call	WaitTOF
	tst.w	ProcessState(pc)
	beq.b	.loop1
	move.w	#2,ProcessState
	movem.l	Registers,d0-a6
.loop2:	bsr.w	VBlank
	movem.l	d0-d1/a0-a1/a6,-(a7)
	move.l	GfxBase(pc),a6
	call	WaitTOF
	movem.l	(a7)+,d0-d1/a0-a1/a6
	cmp.w	#3,ProcessState
	bne.b	.loop2
	move.w	#4,ProcessState
	rts

;; ******************** Internal routines ********************

TestMouse:
	; Exit if LMB pressed.
	btst.b	#6,$bfe001
	beq.b	Exit
	rts

GetScreen:
	move.l	_Screen(pc),a3
	move.l	sc_ViewPort+vp_RasInfo(a3),a3
	move.l	#BitMap1,a2
	add.l	#BitMap2,a2
	sub.l	ri_BitMap(a3),a2	; Other BitMap.
	move.l	bm_Planes(a2),a1
	; A1 = PlanePtr of Undisplayed BitMap
	; A2 = Undisplayed BitMap
	; A3 = _Screen->Viewport.RasInfo
	rts

DoubleBuffer:
	bsr.w	GetScreen
	move.l	a2,ri_BitMap(a3)	; Do the switch.
	move.l	GfxBase(pc),a6
	move.l	_Screen(pc),a0
	lea.l	sc_ViewPort(a0),a0
	jmp	(_LVOScrollVPort,a6)	; And display it.

ClearEdges:
	tst.w	C2PEdgeState
	beq.b	.ok
	bsr.w	GetScreen
	move.w	#256*8-1,d7
.loop:	clr.l	(a1)+
	lea.l	40-8(a1),a1
	clr.l	(a1)+
	dbf	d7,.loop
	clr.w	C2PEdgeState
.ok:	rts

	; *** Adjust this include path! ***
	include	C2P1x1x8.S
	include	C2P2x1x8.S

;; ******************** Callable routines ********************

Update128x128:
	; Update the screen in 2x2 resolution
	; using the supplied 128x128 linear chunky buffer.
	; The sides will get color 0.
	; Callable from Init and Main.
	; Input: A0 = Chunky buffer
	bsr.w	TestMouse
	movem.l	d0-a6,-(a7)
	bsr.w	ClearEdges
	tst.w	C2P2x1State(pc)
	blt.b	.ok
	move.w	#128,d0
	move.w	#128,d1
	moveq.l	#40,d2
	move.w	#8+15*40,d3
	bsr.w	C2P2x1x8_SetSizes
	move.w	#-1,C2P2x1State
	move.l	8*4(a7),a0
.ok:	bsr.w	GetScreen
	addq.l	#4,a1
	bsr.w	C2P2x1x8
	move.l	8*4(a7),a0
	bsr.w	GetScreen
	lea.l	8*40+4(a1),a1
	bsr.w	C2P2x1x8
	bsr.w	DoubleBuffer
	movem.l	(a7)+,d0-a6
	rts

Update160x128:
	; Update the screen in 2x2 resolution
	; using the supplied 160x128 linear chunky buffer.
	; Callable from Init and Main.
	; Input: A0 = Chunky buffer
	bsr.w	TestMouse
	movem.l	d0-a6,-(a7)
	move.w	#-1,C2PEdgeState
	tst.w	C2P2x1State(pc)
	bgt.b	.ok
	move.w	#160,d0
	move.w	#128,d1
	moveq.l	#40,d2
	move.w	#15*40,d3
	bsr.w	C2P2x1x8_SetSizes
	move.w	#1,C2P2x1State
	move.l	8*4(a7),a0
.ok:	bsr.w	GetScreen
	bsr.w	C2P2x1x8
	move.l	8*4(a7),a0
	bsr.w	GetScreen
	lea.l	8*40(a1),a1
	bsr.w	C2P2x1x8
	bsr.w	DoubleBuffer
	movem.l	(a7)+,d0-a6
	rts

Update256x256:
	; Update the screen in 1x1 resolution
	; using the supplied 256x256 linear chunky buffer.
	; The sides will get color 0.
	; Callable from Init and Main.
	; Input: A0 = Chunky buffer
	bsr.w	TestMouse
	movem.l	d0-a6,-(a7)
	bsr.w	ClearEdges
	tst.w	C2P1x1State(pc)
	blt.b	.ok
	move.w	#256,d0
	move.w	#256,d1
	moveq.l	#40,d2
	move.w	#8+7*40,d3
	bsr.w	C2P1x1x8_SetSizes
	move.w	#-1,C2P1x1State
	move.l	8*4(a7),a0
.ok:	bsr.w	GetScreen
	addq.l	#4,a1
	lea.l	TempBuffer,a2
	bsr.w	C2P1x1x8
	bsr.w	DoubleBuffer
	movem.l	(a7)+,d0-a6
	rts

Update320x256:
	; Update the screen in 1x1 resolution
	; using the supplied 320x256 linear chunky buffer.
	; Callable from Init and Main.
	; Input: A0 = Chunky buffer
	bsr.w	TestMouse
	movem.l	d0-a6,-(a7)
	move.w	#-1,C2PEdgeState
	tst.w	C2P1x1State(pc)
	bgt.b	.ok
	move.w	#320,d0
	move.w	#256,d1
	moveq.l	#40,d2
	move.w	#7*40,d3
	bsr.w	C2P1x1x8_SetSizes
	move.w	#1,C2P1x1State
	move.l	8*4(a7),a0
.ok:	bsr.w	GetScreen
	lea.l	TempBuffer,a2
	bsr.w	C2P1x1x8
	bsr.w	DoubleBuffer
	movem.l	(a7)+,d0-a6
	rts

CacheClear:
	; Clear caches so written SMC will be valid.
	; Callable from Init, VBlank and Main.
	movem.l	d0-d1/a0-a1/a6,-(a7)
	move.l	$4.w,a6
	call	CacheClearU
	movem.l	(a7)+,d0-d1/a0-a1/a6
	rts

SetPalette:
	; Set the screen palette to the one supplied.
	; Format is 256 longwords in $xxrrggbb.
	; The upper byte of each longword is ignored.
	; Callable from Init, VBlank and Main.
	; Input: A0 = Palette
	movem.l	d0-d2/a0-a2/a6,-(a7)
	lea.l	.data(pc),a1
	lea.l	4(a1),a2
	move.w	#256-1,d2
.loop:	move.w	(a0)+,d0
	move.b	d0,(a2)
	addq.l	#4,a2
	move.b	(a0)+,d0
	move.b	d0,(a2)
	addq.l	#4,a2
	move.b	(a0)+,d0
	move.b	d0,(a2)
	addq.l	#4,a2
	subq.b	#1,d2
	bne.b	.loop

	move.l	GfxBase(pc),a6
	move.l	_Screen(pc),a0
	lea.l	sc_ViewPort(a0),a0
	call	LoadRGB32
	movem.l	(a7)+,d0-d2/a0-a2/a6
	rts
.data:
	dc.w	256,0
	dcb.l	256*3
	dc.w	0
	
;; ********************************************************
;; ******************** Your code here ********************
;; ********************************************************

Code_Start:

Init:	; Called once in the beginning.
	; Registers are undefined.

	rts
	
VBlank:	; Called every vblank after Init has finished.

	rts

Main:	; Called once when Init has finished.
	; Registers are as left by Init.
	; If it terminates, the demo will exit.
	
	rts

;	uncomment this when you are using ASM-One

;		printt	"Length of your code"
;Code_End:	printv	Code_End-Code_Start

;; ******************** BSS area ********************

	section	BSS_Area,bss

; declare BSS vars here. and only here


;; ******************** Internal BSS area ********************

	section	TempBuffer,bss

TempBuffer:	ds.b	320*256/2
Registers:	ds.l	15

	section	Planes,bss_c

Planes1:	ds.l	320*256/32*8
Planes2:	ds.l	320*256/32*8

;; ******************** Screen setup ********************
